/*
 * MosP - Mind Open Source Project         http://www.mosp.jp/
 * Copyright (C) 1987-2009 MIND Co., Ltd.  http://www.e-mind.co.jp/
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */
package jp.mosp.payroll.payment.action;

import java.util.Date;
import java.util.List;

import jp.mosp.common.common.BaseVo;
import jp.mosp.common.common.MospConst;
import jp.mosp.common.common.MospException;
import jp.mosp.common.common.MospUtility;
import jp.mosp.payroll.base.PayrollAction;
import jp.mosp.payroll.base.PayrollConst;
import jp.mosp.payroll.dao.PhPaymentDao;
import jp.mosp.payroll.dto.PhPaymentDto;
import jp.mosp.payroll.payment.vo.CalcPaymentVo;

/**
 * 給与計算画面における処理を行う。<br><br>
 * 以下のコマンドを扱う。
 * <ul><li>
 * {@link #CMD_SHOW}
 * </li><li>
 * {@link #CMD_EXECUTE}
 * </li></ul>
 */
public class CalcPaymentAction extends PayrollAction {
	
	/**
	 * 画面表示コマンド。<br><br>
	 * 給与計算中の年月を取得、表示する。<br>
	 * もし給与計算中の年月がなかった場合は、警告する。<br>
	 * 給与計算中の年月における給与データが存在した場合も、警告する。<br>
	 */
	public static final String CMD_SHOW = "P1230";
	
	/**
	 * 処理実行コマンド。<br><br>
	 * 表示された計算年月に対して、給与計算を行う。<br>
	 */
	public static final String CMD_EXECUTE = "P1235";
	
	/**
	 * Actionの初期化を行う。<br><br>
	 * 以下の処理を行う。
	 * <ul><li>
	 * {@link PayrollAction#PayrollAction()}
	 * </li></ul>
	 */
	public CalcPaymentAction() {
		super();
	}
	
	/* (non-Javadoc)
	 * @see jp.mosp.common.common.BaseAction#getSpecificVo()
	 */
	@Override
	protected BaseVo getSpecificVo() {
		return new CalcPaymentVo();
	}
	
	/**
	 * アクション。<br>
	 * 詳細は、クラス説明を参照。<br>
	 */
	public void action() throws Exception {
		// VO取得及び設定
		prepareVo();
		if (this.cmd.equals(CMD_SHOW)) {
			// 画面表示
			show();
		} else if (this.cmd.equals(CMD_EXECUTE)) {
			// 処理実行
			execute();
		} else {
			throw new MospException(MospConst.EX_CMD_INVALID);
		}
	}
	
	/**
	 * 画面表示処理を行う。<br>
	 * @throws Exception 
	 */
	private void show() throws Exception {
		// コネクション取得
		getConnection();
		// VO取得
		CalcPaymentVo vo = (CalcPaymentVo)getVo();
		// 計算中情報取得
		Date current = getCurrent(PayrollConst.OFFICE_ALL, PayrollConst.CALC_PAYMENT);
		// 計算中情報確認
		if (current == null) {
			// 画面モード設定
			vo.setMode(1);
			// 警告メッセージ設定
			vo.addErrMessage(MospUtility.getMessage(msg, "WP1210",	""));
			// 例外スロー
			throw new MospException(MospConst.EX_PARAMS_INVALID);
		}
		// 給与データ存在確認
		List<PhPaymentDto> list = new PhPaymentDao(cfg, cmd, aspUser, user, conn).find(current);
		if (list.size() > 0) {
			// 警告メッセージ設定
			vo.addErrMessage(MospUtility.getMessage(msg, "WP1220",
					MospUtility.getDateString(current, PayrollConst.FORMAT_YEAR_MONTH) +
					MospConst.DATA_SEPARATOR + vo.getName("P_PAYMENT")));
		}
		// VOフィールド設定
		vo.setCalcDate(current);
		// 画面モード設定
		vo.setMode(0);
	}
	
	/**
	 * 給与計算処理を行う。<br>
	 * @throws Exception 
	 */
	private void execute() throws Exception {
		// コネクション取得
		getConnection();
		// VO取得
		CalcPaymentVo vo = (CalcPaymentVo)getVo();
		// 対象年月取得
		Date targetMonth = vo.getCalcDate();
		// 計算月確認
		if (!isCurrent(targetMonth, PayrollConst.OFFICE_ALL, PayrollConst.CALC_PAYMENT)) {
			// メッセージ設定
			addErrMessage(MospUtility.getMessage(msg, "WP1211", ""));
			return;
		}
		// 計算対象者取得
		Date startDate = getStartDate(targetMonth);
		String[] aryEmployee = getTargetEmployee(startDate);
		// 給与計算
		for (int i = 0; i < aryEmployee.length; i++) {
			calcPayment(aryEmployee[i], targetMonth);
		}
		// コミット
		commit();
		// メッセージ設定
		setMessage(MospUtility.getMessage(msg, "IP1230",
				MospUtility.getDateString(targetMonth, PayrollConst.FORMAT_YEAR_MONTH)));
		// 次コマンド設定(給与計算画面へ)
		setNextCmd(PaymentListAction.CMD_SHOW);
	}
	
}
